  # ##################
  #
  #   hugecombo demo
  #
  # ##################

  # ------------------
  # imaged demo
  # ------------------

  # append:dirs directories hierarchy proc
  # ------------------
  proc append:dir {root pwd left} \
  {
    # root dir
    set rdir [lindex $pwd 0]
    # subdirs
    set pwd [lrange $pwd 1 end]
    # siblings
    set dirs [glob -types d -dir $root *]
    foreach dir $dirs \
    {
      # for each sibling
      set dir [file tail $dir]
        # append dir
      lappend ::names $dir
      lappend ::confs [list $::index $left img_dir]
      incr ::index
      if {$dir == $rdir} \
      { 
        # subdir of pwd
        set ::current $::index
        if {[llength $pwd] > 0} \
        { append:dir $root/$rdir $pwd [expr {$left + 15}] }
      }
    }
  }
  
  # create the directories hierarchy lists
  # ------------------
  # the root units
  set units [file volume]
  # the dirs of the current path
  set pwd [file split [file normalize [pwd]]]
  # create the hierarchy
    # root unit of pwd
  set root [lindex $pwd 0]
    # build lists
  set index 0
  foreach unit $units \
  {
    # append unit
    set left 15
    lappend names [list $unit]
    lappend confs [list $index $left img_unit]
    incr index
    # test if root unit of pwd
    if {$unit == $root} { append:dir $root [lrange $pwd 1 end] 30 }
  }
  
  # show the hierarchy
  # ------------------
  # load the package
  lappend auto_path [file join [pwd] ..]
  package require Hugecombo
  namespace import ::hugecombo::hugecombo
  # create the hugecombo
  hugecombo .hc -list ::names -width 30 -height 7 -state picklist \
            -compound 1 -rowheight 20 -alternate gray97
  pack .hc -fill x -expand 1
  # create the images
  image create photo img_unit -file disk.gif
  image create photo img_dir -file dir.gif
  # imaging the items
  foreach conf $confs \
  {
    foreach {index left image} $conf break
    .hc itemconf $index -left $left -image $image
  }
  # load & show the current directory
  .hc load $current
  .hc list find [lindex $names $current]
  .hc list open
